//  RegistryKey key = Registry.LocalMachine.OpenSubKey(@"Software\Alachisoft\NCache");
//	string DsFilePath = Path.Combine(key.GetValue("InstallDir").ToString(),
//	@"samples\northwinddb\northwind.mdb");

using System;
using System.Collections;
using System.Data;
using System.Drawing;
using System.Data.OleDb;
using System.Windows.Forms;
using System.Globalization;

using Alachisoft.NCache.Web.Caching;
using CustomDependency.Business;
using Alachisoft.NCache.Runtime.Dependencies;

namespace CustomDependency.UI
{
	public class CacheViewer : Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.IContainer components = null;

		private System.Windows.Forms.Button btnLoad;
		private System.Windows.Forms.ListView lvwSyncItems;
		private System.Windows.Forms.Button btnDone;
		private System.Windows.Forms.ColumnHeader clmProductId;
		private System.Windows.Forms.ColumnHeader clmProductName;
		private System.Windows.Forms.GroupBox gbMain;
		private System.Windows.Forms.Label lblCount;
		private System.Windows.Forms.Label lblMessage;
		private System.Windows.Forms.Label lblCacheCount;

		private OleDbDatasource _datasource;
		private OleDbConnection _connection;
		private string			_dsFilePath;
		private string			_connString;

        private string _msg = "";
		private System.Windows.Forms.ColumnHeader clmUnitInStocks;

        #region Delegates
        public delegate void UpdateLvwDelegate();
        #endregion

		public static Cache _cache;


		public CacheViewer()
		{
			InitializeCache();
			InitializeComponent();
            _connString = System.Configuration.ConfigurationSettings.AppSettings["conn-string"].ToString();
            _datasource = new OleDbDatasource();
            //_datasource.SetUnitsInStocks(150);
			_cache.ItemRemoved += new CacheItemRemovedCallback(Cache_ItemRemoved);

			btnLoad_Click(this, EventArgs.Empty);
			this.Visible = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		/// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
		protected override void Dispose(bool disposing)
		{
			if (disposing && (components != null))
			{
				components.Dispose();
			}
			
			if (_connection != null)
				_connection.Close();

			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code

		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.btnLoad = new System.Windows.Forms.Button();
            this.lvwSyncItems = new System.Windows.Forms.ListView();
            this.clmProductId = new System.Windows.Forms.ColumnHeader();
            this.clmProductName = new System.Windows.Forms.ColumnHeader();
            this.clmUnitInStocks = new System.Windows.Forms.ColumnHeader();
            this.btnDone = new System.Windows.Forms.Button();
            this.gbMain = new System.Windows.Forms.GroupBox();
            this.lblCount = new System.Windows.Forms.Label();
            this.lblMessage = new System.Windows.Forms.Label();
            this.lblCacheCount = new System.Windows.Forms.Label();
            this.gbMain.SuspendLayout();
            this.SuspendLayout();
            // 
            // btnLoad
            // 
            this.btnLoad.BackColor = System.Drawing.SystemColors.Control;
            this.btnLoad.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnLoad.Location = new System.Drawing.Point(224, 352);
            this.btnLoad.Name = "btnLoad";
            this.btnLoad.Size = new System.Drawing.Size(65, 25);
            this.btnLoad.TabIndex = 1;
            this.btnLoad.Text = "&Refresh";
            this.btnLoad.UseVisualStyleBackColor = false;
            this.btnLoad.Click += new System.EventHandler(this.btnLoad_Click);
            // 
            // lvwSyncItems
            // 
            this.lvwSyncItems.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.clmProductId,
            this.clmProductName,
            this.clmUnitInStocks});
            this.lvwSyncItems.GridLines = true;
            this.lvwSyncItems.Location = new System.Drawing.Point(7, 19);
            this.lvwSyncItems.Name = "lvwSyncItems";
            this.lvwSyncItems.Size = new System.Drawing.Size(345, 245);
            this.lvwSyncItems.TabIndex = 5;
            this.lvwSyncItems.UseCompatibleStateImageBehavior = false;
            this.lvwSyncItems.View = System.Windows.Forms.View.Details;
            // 
            // clmProductId
            // 
            this.clmProductId.Text = "Product ID";
            this.clmProductId.Width = 78;
            // 
            // clmProductName
            // 
            this.clmProductName.Text = "Product Name";
            this.clmProductName.Width = 133;
            // 
            // clmUnitInStocks
            // 
            this.clmUnitInStocks.Text = "Units In Stocks";
            this.clmUnitInStocks.Width = 130;
            // 
            // btnDone
            // 
            this.btnDone.BackColor = System.Drawing.SystemColors.Control;
            this.btnDone.DialogResult = System.Windows.Forms.DialogResult.Cancel;
            this.btnDone.Location = new System.Drawing.Point(296, 352);
            this.btnDone.Name = "btnDone";
            this.btnDone.Size = new System.Drawing.Size(65, 25);
            this.btnDone.TabIndex = 6;
            this.btnDone.Text = "&Close";
            this.btnDone.UseVisualStyleBackColor = false;
            this.btnDone.Click += new System.EventHandler(this.btnDone_Click);
            // 
            // gbMain
            // 
            this.gbMain.Controls.Add(this.lvwSyncItems);
            this.gbMain.Location = new System.Drawing.Point(10, 72);
            this.gbMain.Name = "gbMain";
            this.gbMain.Size = new System.Drawing.Size(358, 270);
            this.gbMain.TabIndex = 0;
            this.gbMain.TabStop = false;
            this.gbMain.Text = "NorthWind Products";
            // 
            // lblCount
            // 
            this.lblCount.BackColor = System.Drawing.Color.Transparent;
            this.lblCount.Location = new System.Drawing.Point(10, 16);
            this.lblCount.Name = "lblCount";
            this.lblCount.Size = new System.Drawing.Size(89, 16);
            this.lblCount.TabIndex = 7;
            this.lblCount.Text = "Cache Count : ";
            // 
            // lblMessage
            // 
            this.lblMessage.BackColor = System.Drawing.Color.WhiteSmoke;
            this.lblMessage.ForeColor = System.Drawing.Color.Black;
            this.lblMessage.Location = new System.Drawing.Point(13, 42);
            this.lblMessage.Name = "lblMessage";
            this.lblMessage.Size = new System.Drawing.Size(344, 16);
            this.lblMessage.TabIndex = 8;
            // 
            // lblCacheCount
            // 
            this.lblCacheCount.BackColor = System.Drawing.Color.WhiteSmoke;
            this.lblCacheCount.ForeColor = System.Drawing.Color.Black;
            this.lblCacheCount.Location = new System.Drawing.Point(89, 16);
            this.lblCacheCount.Name = "lblCacheCount";
            this.lblCacheCount.Size = new System.Drawing.Size(52, 16);
            this.lblCacheCount.TabIndex = 9;
            // 
            // CacheViewer
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.Color.WhiteSmoke;
            this.CancelButton = this.btnDone;
            this.ClientSize = new System.Drawing.Size(378, 383);
            this.Controls.Add(this.lblCacheCount);
            this.Controls.Add(this.lblMessage);
            this.Controls.Add(this.lblCount);
            this.Controls.Add(this.gbMain);
            this.Controls.Add(this.btnDone);
            this.Controls.Add(this.btnLoad);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Location = new System.Drawing.Point(550, 75);
            this.MaximizeBox = false;
            this.Name = "CacheViewer";
            this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
            this.Text = "Cache Viewer";
            this.gbMain.ResumeLayout(false);
            this.ResumeLayout(false);

		}

		#endregion


		#region >>      === Notification Handler(s) ===     <<

		void Cache_ItemRemoved(object key, object value, CacheItemRemovedReason reason)
		{
            //UpdateView();
            _msg = "Removing product with 'ProductID = " + key.ToString() + "' from the cache";
            this.Invoke(new UpdateLvwDelegate(UpdateView));
            //int currentCount = Convert.ToInt32(this.lblCount.Text) - 1;
            //this.lblCacheCount.Text = currentCount.ToString();
        }

		#endregion 

		#region >>      === Event Handler(s) ===        <<

		private void btnLoad_Click(object sender, EventArgs e)
		{
            _datasource.SetUnitsInStocks(150);
            LoadCache();
			UpdateView();
		}

		private void UpdateView()
		{
			lvwSyncItems.Items.Clear();
			lock(this)
			{
				IDictionaryEnumerator ide = (IDictionaryEnumerator)_cache.GetEnumerator();
                while (ide.MoveNext())
                {
                    Product product = ide.Value as Product;
                    if (product != null)
                    {
                        string[] str = { product.ProductID.ToString(), product.ProductName, product.UnitsAvailable.ToString() };
                        ListViewItem lvItem = new ListViewItem(str);
                        lvwSyncItems.Items.Add(lvItem);
                    }
                }
			}
            this.lblMessage.Text = _msg;
            this.lblCacheCount.Text = _cache.Count.ToString();
        }

		private void btnDone_Click(object sender, EventArgs e)
		{
			this.DisposeCache();
			this.Close();
		}

		#endregion


		#region >>      === Cache Operation(s) ===      <<

		private void LoadCache()
		{
			Product[] products = _datasource.LoadProducts();
			CacheItem[] items = new CacheItem[products.Length];
			String[] keys = new String[products.Length];

			for (int i=0; i<products.Length; i++)
			{
				keys[i] = products[i].ProductID.ToString();
				CacheItem item = new CacheItem(products[i]);
				item.Dependency = new CacheDependency(new CustomDependency.Dependency(products[i].ProductID, _connString));
				items[i] = item;
			}

			_cache.AddBulk(keys,items,DSWriteOption.None,null );
            _msg = "Items loaded in Cache successfully.";
		}

		private void InitializeCache()
		{
            try
            {
                _cache = NCache.InitializeCache("myCache");                 
            }
            catch (Exception ex)
            {
                MessageBox.Show("Error occured while trying to initialize Cache named: [myCache]]\nException: " + ex.Message,
                "Cache Viewer", 
                MessageBoxButtons.OK,
                MessageBoxIcon.Error);
            }
		}


		private void DisposeCache()
		{
			_cache.Dispose();
		}

		private Product[] LoadProducts()
		{			
			OleDbDataReader reader = null;
			Product[] products = new Product[15];
			int i = 0;
			try
			{
				_connection = new OleDbConnection(_connString);
				_connection.Open();
				
				OleDbCommand cmd = _connection.CreateCommand();
				cmd.CommandText = String.Format(CultureInfo.InvariantCulture, 
					"Select ProductID, ProductName, UnitsInStock" + 
					" From Products where ProductID < 16");

				reader = cmd.ExecuteReader();
					
				while(reader.Read())
				{
					Product product = new Product();

					product.ProductID		= (int)reader["ProductID"];
					product.ProductName		= reader["ProductName"].ToString();
					product.UnitsAvailable	= Convert.ToInt32(reader["UnitsInStock"].ToString());
					
					products[i++] = product;
				}
				reader.Close();
			}
			catch(Exception e)
			{
				System.Diagnostics.Trace.WriteLine(e);
			}
			return products;
		}

		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			try
			{
				Application.Run(new CacheViewer());
			}
			catch(Exception e)
			{
				MessageBox.Show(e.Message, "Error");
			}
            _cache.Dispose();
		}
	}
}